GAP = '-'

# pre:  U and V are sequences (that may include gaps
# post: returns the similarity score of self and other
#          where c is the match value and g
#          is the gap penalty
# modifies: nothing

def goodnessScore (U, V, c, g):
    # replace this stub with your code
    return 0

# pre: U and V are strings; c and g are numbers
# post: Returns the best possible alignment of U and V given c and g
#       as two values (U', V') where U' is U with gaps inserted and V' 
#       is V with gaps inserted such that the goodnessScore of
#       U' and V' is the maximum possible goodnessScore that can
#       be obtained by adding gaps to U and V.
def bestAlignment (U, V, c, g):  
    if len(U) == 0 or len(V) == 0:
        while len(U) < len(V): U = U + GAP
        while len(V) < len(U): V = V + GAP
        return U, V
    else:
        # try with no gap
        (U0, V0) = bestAlignment (U[1:], V[1:], c, g)
        scoreNoGap = goodnessScore (U0, V0, c, g)
        if U[0] == V[0]: scoreNoGap += c
        
        # try inserting a gap in U (no match for V[0])
        (U1, V1) = bestAlignment (U, V[1:], c, g)
        scoreGapU = goodnessScore (U1, V1, c, g) - g
        
        # try inserting a gap in V (no match for U[0])
        (U2, V2) = bestAlignment (U[1:], V, c, g)
        scoreGapV = goodnessScore (U2, V2, c, g) - g
        
        if scoreNoGap >= scoreGapU and scoreNoGap >= scoreGapV:
            return U[0] + U0, V[0] + V0
        elif scoreGapU >= scoreGapV:
            return GAP + U1, V[0] + V1
        else:
            return U[0] + U2, GAP + V2

           
           
       
       
